<template>
	<div :id="id" class="u-block-spacing" :class="$style.block">
		<h2 class="u-heading u-heading--pre-line" :class="$style.heading">{{ heading }}</h2>

		<dl>
			<template v-for="(item, index) in questions">
				<dt :key="`question-${index}`" :class="[$style.dt, { [$style.dtActive]: open[index] }]">
					<button
						type="button"
						:class="$style.button"
						:aria-expanded="open[index] ? 'true' : 'false'"
						:aria-controls="`${randomId}-faq-${index}`"
						@click="toggle(index)"
					>
						{{ item.question }}
						<BaseIcon
							:class="$style.icon"
							name="chevron-right"
							title="Read Answer"
							width="20"
							height="20"
							fill="#8e949d"
						/>
					</button>
				</dt>
				<dd :key="`answer-${index}`" :class="[$style.dd, { [$style.ddActive]: open[index] }]">
					<div
						v-show="open[index]"
						:id="`${randomId}-faq-${index}`"
						v-rich-content
						:class="$style.answer"
						v-html="item.answer"
					/>
				</dd>
			</template>
		</dl>
	</div>
</template>

<script>
export default {
	props: {
		id: {
			type: String,
			default: null,
		},

		heading: {
			type: String,
			default: 'Frequently asked questions',
		},

		questions: {
			type: Array,
			default: () => [],
		},
	},

	data() {
		return { open: {}, randomId: Math.floor(Math.random() * 1000000000) };
	},

	methods: {
		toggle(index) {
			this.$set(this.open, index, !this.open[index]);
		},
	},
};
</script>

<style lang="scss" module>
@import '@design';

$chevron-space: 4rem;

.block {
	max-width: 94rem;
	padding: 0 size('s');
	margin: 0 auto;
}

.dt,
.dd {
	padding-right: size('s') + $chevron-space;
	padding-left: size('s');
}

.dt {
	padding-top: size('s');
	padding-bottom: size('s');
	color: color('primary-300');
	border: 1px solid color('border');
	border-radius: 0.04rem;

	@include use-text-style('type');
	@include use-text-style('type-200');
}

.button {
	position: relative;
	display: block;
	width: 100%;
	text-align: left;
}

.icon {
	position: absolute;
	top: 0.2rem;
	right: -4.4rem;
	transform: rotate(90deg);
}

.dd {
	margin-bottom: size('s');
}

.answer {
	padding-bottom: size('s');
	color: color('primary-200');

	@include use-text-style('type');
	@include use-text-style('type-100');

	p {
		&:not(:last-child) {
			margin-bottom: size('s');
		}
	}
}

.dtActive {
	border-bottom: 0;
	border-radius: 0.4rem 0.4rem 0 0;

	.icon {
		transform: rotate(-90deg);
	}
}

.ddActive {
	border: 1px solid color('border');
	border-top: 0;
	border-radius: 0 0 0.4rem 0.4rem;
}
</style>
